<?php
    require_once('/home/kaa2nx/.mysqlpass.inc.php');
    
    // create our database connection
    
    // probably catch errors
    $connection = new PDO(
        "mysql:host=localhost",
        "dbuser",
        MySQLPassword::$password
    );
    
    // select our database
    $connection->query("USE class_examples;");
    
    // now we're in the right database
    
    // we might have two different commands:
    // 1) Get To Do items
    // 2) Save new To Do item
    
    // we chose to set the command in the "cmd" post variable
    if(isset($_POST["cmd"])) {
        if ( $_POST["cmd"] == "store") {
            // the web app wants us to store data
            $todo = json_decode($_POST["data"]);
            $prepared = $connection->prepare("INSERT INTO todo (description,due,priority,complete) VALUES (:desc,:due,:priority,0)");
            
            if(!$prepared->execute([":desc" => $todo->desc,
                                    ":due" => $todo->due,
                                    ":priority" => $todo->priority])) {
                echo json_encode(array("error" => true, "info" => $connection->errorInfo()));
                exit();
            }
            
            echo json_encode(array("error" => false, "id" => $connection->lastInsertId()));
            
            
        } else if ( $_POST["cmd"] == "get") {
            // the web app wants us to return current
            // to do list
            
            $result = $connection->query("SELECT id,description as 'desc',priority,due FROM todo WHERE complete = 0");
            
            if(!$result) {
                echo json_encode(array("error" => true, "info" => $connection->errorInfo()));
                exit();
            }
            
            echo json_encode(array("error" => false, "event" => $result->fetchAll()));
            
        } else if ( $_POST["cmd"] == "finish") {
            $prepared = $connection->prepare("UPDATE todo SET complete=1 WHERE id=:id");
            if(!$prepared->execute([":id" => $_POST["id"]])) {
                echo json_encode(array("error" => true, "info" => $connection->errorInfo()));
                exit();
            }
            
            echo json_encode(array("error"=> false));
        }
    }

?>