//$(document).ready(handler)
// same as $(handler)

// when the dom is ready
$(function() {
    // things to do once the page has loaded
    
    var request = $.ajax({
        type: "POST",
        url: "server.php",
        dataType: "json",
        cache: "false",
        data : {
            cmd: "get"
        }
    });
    
    request.done(function(data){
        if(data.error) {
            alert("couldn't load stored to do items.")
        } else {
            // is there a table
            if($('#todo table').length === 0 && data.event.length > 0) {
                // there is no table yet, so add it
                $('#todo').append('<table class="table" id="todo-table"><thead><tr><th>Description</th><th>Priority</th><th>Due Date</th><th></th></tr></thead><tbody id="todo-body"></tbody></table>');
            }
            
            $.each(data.event, function(id,itm) {
                var eventHTML = $('<tr id="'+itm.id+'"><td>'+itm.desc+'</td><td>'+itm.priority+'</td><td class="todo-date">'+itm.due+'</td><td><span class="glyphicon glyphicon-remove todo-remove"></span></td></tr>');
                $("#todo-body").append(eventHTML);
            });
        }
    });
    
    // handler for when the button is clicked
    $("#add").click(function(evt){
        evt.preventDefault();
        
        // validate the form input
        var desc = $('#description').val();
        if(desc === "") {
            $('#description').parent().addClass("has-error");
            alert("You have an empty description!");
            return;
        }
        
        var due = $('#due').val();
        if(due === "" || isNaN((new Date(due)).valueOf()) ) {
            $('#due').parent().addClass("has-error");
            alert("You have an invalid due date");
            return;
        }
        
        var priority = $('#priority').val();
        
        var todo = {
            desc: desc,
            due : new Date(due),
            priority: priority
        };
        
        // is there a table
        if($('#todo table').length === 0) {
            // there is no table yet, so add it
            $('#todo').append('<table class="table" id="todo-table"><thead><tr><th>Description</th><th>Priority</th><th>Due Date</th><th></th></tr></thead><tbody id="todo-body"></tbody></table>');
        }
        // add the event
        
        
        
        
        
        // store the todo on the server
        var request = $.ajax({
            type: "POST",
            url: "server.php",
            dataType: "json",
            cache: false,
            data : {
                cmd : "store",
                data: JSON.stringify(todo)
            }
        });
        
        request.done(function(data){
            if(data.error) {
                alert("something went wrong and your last todo wasn't stored");
            } else {
                var eventHTML = $('<tr><td>'+desc+'</td><td>'+priority+'</td><td class="todo-date">'+due+'</td><td><span class="glyphicon glyphicon-remove todo-remove"></span></td></tr>');
                eventHTML.attr('id',data.id);
                $("#todo-body").append(eventHTML);
                
                //empty the submission form
                $('#description').val("");
                $('#due').val("");
                $('#priority').val("normal");
                
                
            }
            
        });
        $('.has-error').removeClass("has-error");
        
    });
    
    $("#todo").on("click", "table .todo-remove", function(evt) {
        evt.preventDefault();
        
        var request = $.ajax({
            type: "POST",
            url: "server.php",
            dataType: "json",
            cache: false,
            data : {
                cmd : "finish",
                id : $(evt.target).parents('tr').attr('id')
            }
        });
        
        request.done(function(data){
            if(data.error) {
                alert("something went wrong and the todo wasn't completed");
            } else {
                $(evt.target).parents('tr').remove();
                if($('#todo-body tr').length === 0 ) {
                    $('#todo table').remove();
                }
            }
        });
        
        
        
    });
    
    setInterval(function() {
        $.each($(".todo-date"),function(index,element) {
            //for each date
            var date = new Date($(element).text());
            var curr = new Date();
            
            if(date < curr) {
                $(element).parents("tr").addClass("red");
            }
        });
    }, 60000);
});